#!/usr/bin/perl

#################################################################################################
#chatctrl.pl
#
#This script creates the control panel for each user and for the Chat Room Admin
#################################################################################################

##########################################################################################
#Configuration Section
##########################################################################################

$chatmaster='elvis';	#the logon of the person in control.
				#The chat master can kick out and banish users and clear the screen,

$cgiurl='http://linux.cqi.com.cn/~elvis/chat4/chat.pl';		#URL for chat.pl(same as in chat.pl)
$cgiurl3='http://linux.cqi.com.cn/~elvis/chat4/chatfunc.pl';	#URL for chatfunc.pl(same as in chat.pl)

##########################################################################################

if ($ENV{'QUERY_STRING'} =~ /logon/)
{
	@pairs = split(/\&/,$ENV{'QUERY_STRING'});
	foreach $pair (@pairs)
	{
		@a = split(/\=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$name =~ s/\+/ /g;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/\+/ /g;
		push (@formdata,$name,$value);
	}
	%formdata=@formdata;

	print "Content-type: text/html\n\n";
	print "<html><title>Control Panel</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "<center>\n";
	print "<table border=0 width=98\%><tr>\n";

	if($formdata{'logon'} eq $chatmaster)
	{
		$logon=$formdata{'logon'};
	}
	else
	{
		$logon="Chat Room Admin";
	}

	print "<td>\n";			#refresh user list and comment window
	print "<center>\n";
	print "<form method=get action=\"$cgiurl3\" target=\"users\">\n";
	print "<input type=hidden name=\"room\" value=\"$formdata{'room'}\">\n";
	print "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	print "<input type=submit name=\"action\" value=\"Refresh User List\">\n";
	print "</form>\n";
	print "<form method=get action=\"$cgiurl3\" target=\"comments\">\n";
	print "<input type=hidden name=\"room\" value=\"$formdata{'room'}\">\n";
	print "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	print "<input type=submit name=\"action\" value=\"Refresh Comment Window\">\n";
	print "</form>\n";
	print "</center>\n";
	print "</td>\n";

	print "<td>\n";			#speak and clear text box
	print "<center>\n";
	print "<form method=post action=\"$cgiurl\" target=\"comments\">\n";
	print "<input type=text name=\"comments\" size=50><br>\n";
	print "<input type=hidden name=\"room\" value=\"$formdata{'room'}\">\n";
	print "<input type=hidden name=\"action\" value=\"speak\">\n";
	print "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	print "<input type=hidden name=\"image\" value=\"$formdata{'image'}\">\n";
	print "<input type=checkbox name=\"private\">Private Message<br>\n";
	print "<input type=submit value=\"Say It\">\n";
	print "<input type=reset value=\"Clear Text Box\">\n";
	print "</form>\n\n";
	print "</center>\n";
	print "</td>\n";

	print "<td>\n";			#logout and clear window(chat room admin)
	print "<form method=post action=\"$cgiurl\" target=\"comments\">\n";
	print "<input type=hidden name=\"room\" value=\"$formdata{'room'}\">\n";
	print "<input type=submit name=\"action\" value=\"Log Out\">\n<br>\n";
	if ($logon eq $chatmaster)
	{
		print "<input type=submit name=\"action\" value=\"Clear Screen\">\n";
		print "<input type=hidden name=\"logon\" value=\"Chat Room Admin\">\n";
	}
	else
	{
		print "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	}
	print "</form>\n\n";
	print "</td>\n";

	print "</tr>\n</table>\n\n";
	print "</center>\n";
	print "</html>";
	exit 0;
}
else
{
	print "Content-type: text/html\n\n";
	print "<html><title>Control Panel</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Go away\n";
	print "</html>\n";
	exit 0;
}

